%option noyywrap
%option yylineno

%{

  /*
   * File version information:
   * $Id: scanner.l 1642 2010-06-07 12:23:18Z corti $
   * $Revision: 1642 $
   * $HeadURL: https://svn.id.ethz.ch/bd_webhosting/tools/svnauthcheck/scanner.l $
   * $Date: 2010-06-07 14:23:18 +0200 (Mon, 07 Jun 2010) $
   */

#include "svnauthcheck.h"
#include "parser.h"

extern int debug_flag;

// ^"#"[^t][^r][^a][^c].*$  

%} 

%s comment

%%

^#trac                   { return TRAC; }
^#[^t].*\n               /* skip commment */
^#t[^r].*\n              /* skip commment */
^#tr[^a].*\n             /* skip commment */
^#tra[^c].*\n            /* skip commment */
^#trac[^\ ].*\n          /* skip commment */

"[groups]"               { return GROUPS;    }
","                      { return COMMA;     }
":"                      { return SEMICOLON; }
"["                      { return LBRACKET;  }
"]"                      { return RBRACKET;  }
"="                      { return EQUAL;     }
"@"                      { return AT;        }
"*"                      { return STAR;      }

("/"[a-zA-Z0-9%,_\-\.\ ]*)+ { 
#ifdef HAVE_STRNDUP
			   yylval.string = strndup(yytext, MAX_USER_SIZE);
#else
			   yylval.string = strdup(yytext);
#endif

                           urldecode(yylval.string);

                           return DIR; }

[a-zA-Z0-9%]([a-zA-Z0-9%@\.\-_]|:[^/])* {
#ifdef HAVE_STRNDUP
			   yylval.string = strndup(yytext, MAX_USER_SIZE);
#else
			   yylval.string = strdup(yytext);
#endif

                           urldecode(yylval.string);

                           return ID; }
^[[:blank:]]             { fprintf(stderr, "Error - %i: spaces are not allowed at the beginnign of a line in svnaccess files\n",
                                   yylineno);
                           exit(SYNTAX_ERROR);
                         }

[[:blank:]]              /* ignore spaces  */

[\n\r]+                  { return NEWLINE; }

.                        { fprintf(stderr, "Error - %i: unknown symbol '%s'\n", yylineno, yytext);
                           exit(SYNTAX_ERROR);  }

%%
